import 'package:flutter/material.dart';

import 'package:sb_bloc/bloc/bloc.dart';

class BlocProvider<T extends Bloc> extends StatefulWidget{

  final T bloc;
  final Widget child;

  BlocProvider({@required this.bloc, @required this.child});

  static T of<T extends Bloc>(BuildContext context) {
    final type = _providerType<BlocProvider<T>>();
    final BlocProvider<T> provider = context.ancestorWidgetOfExactType(type);
    return provider.bloc;
  }

  static Type _providerType<T>() => T;

  @override
  State<StatefulWidget> createState() => BlocProviderState();
}

class BlocProviderState extends State<BlocProvider>{

  @override
  void dispose() {
    widget.bloc.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) => widget.child;
}